QuantLib: Instrument Class Reference

A free/open-source library for quantitative finance Reference manual - version 1.6

- Main Page
- Related Pages
- Modules
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Attributes | List of all members
Instrument Class Referenceabstract

Abstract instrument class. More...

`#include <ql/instrument.hpp>`

Inherits LazyObject.

Inherited by Bond, CapFloor, CDO, Commodity, CompositeInstrument, CPICapFloor, CreditDefaultSwap, Forward, NthToDefault, Option, PathMultiAssetOption, RiskyAssetSwap, RiskyAssetSwapOption, RiskyBond, Stock, Swap, SyntheticCDO, VarianceOption, VarianceSwap, and YoYInflationCapFloor.

## Public Member Functions
virtual void | setupArguments (PricingEngine::arguments *) const
virtual void | fetchResults (const PricingEngine::results *) const
Inspectors
Real | NPV () const
| returns the net present value of the instrument.
Real | errorEstimate () const
| returns the error estimate on the NPV when available.
const Date & | valuationDate () const
| returns the date the net present value refers to.
template<typename T >
T | result (const std::string &tag) const
| returns any additional result returned by the pricing engine.
const std::map< std::string, boost::any > & | additionalResults () const
| returns all additional result returned by the pricing engine.
virtual bool | isExpired () const =0
| returns whether the instrument might have value greater than zero.
Modifiers
void | setPricingEngine (const boost::shared_ptr< PricingEngine > &)
| set the pricing engine to be used. More...
Public Member Functions inherited from LazyObject
void | update ()
void | recalculate ()
void | freeze ()
void | unfreeze ()
Public Member Functions inherited from Observable
| Observable (const Observable &)
Observable & | operator= (const Observable &)
void | notifyObservers ()
Public Member Functions inherited from Observer
| Observer (const Observer &)
Observer & | operator= (const Observer &)
std::pair< std::set< boost::shared_ptr< Observable > >::iterator, bool > | registerWith (const boost::shared_ptr< Observable > &)
void | registerWithObservables (const boost::shared_ptr< Observer > &)
Size | unregisterWith (const boost::shared_ptr< Observable > &)
void | unregisterWithAll ()

## Protected Member Functions
Calculations
void | calculate () const
virtual void | setupExpired () const
virtual void | performCalculations () const
Protected Member Functions inherited from LazyObject

## Protected Attributes
boost::shared_ptr< PricingEngine > | engine_
Results
The value of this attribute and any other that derived classes might declare must be set during calculation.
Real | NPV_
Real | errorEstimate_
Date | valuationDate_
std::map< std::string, boost::any > | additionalResults_
Protected Attributes inherited from LazyObject
bool | calculated_
bool | frozen_

## Detailed Description

Abstract instrument class.

This class is purely abstract and defines the interface of concrete instruments which will be derived from this one.

Tests:
  observability of class instances is checked.

## Member Function Documentation

void setPricingEngine | ( | const boost::shared_ptr< PricingEngine > & | e | ) |

set the pricing engine to be used.

Warning:
  calling this method will have no effects in case the performCalculation method was overridden in a derived class.

void setupArguments | ( | PricingEngine::arguments * |  | ) | const
| virtual

When a derived argument structure is defined for an instrument, this method should be overridden to fill it. This is mandatory in case a pricing engine is used.

Reimplemented in Bond, CallableFixedRateBond, SyntheticCDO, CPISwap, ContinuousPartialFixedLookbackOption, CreditDefaultSwap, FloatFloatSwap, ZeroCouponInflationSwap, VanillaSwap, NthToDefault, YearOnYearInflationSwap, EnergyCommodity, CPICapFloor, ContinuousPartialFloatingLookbackOption, AssetSwap, NonstandardSwap, CallableBond, Swaption, IrregularSwap, YoYInflationCapFloor, CapFloor, DiscreteAveragingAsianOption, VarianceSwap, VanillaSwingOption, ContinuousFixedLookbackOption, VarianceOption, Swap, IrregularSwaption, DividendVanillaOption, ForwardVanillaOption, CdsOption, CliquetOption, WriterExtensibleOption, NonstandardSwaption, MultiAssetOption, HimalayaOption, PagodaOption, BarrierOption, DoubleBarrierOption, PathMultiAssetOption, DividendBarrierOption, FloatFloatSwaption, ContinuousAveragingAsianOption, TwoAssetBarrierOption, VanillaStorageOption, CompoundOption, MargrabeOption, ContinuousFloatingLookbackOption, SimpleChooserOption, and Option.

void fetchResults | ( | const PricingEngine::results * | r | ) | const
| virtual

When a derived result structure is defined for an instrument, this method should be overridden to read from it. This is mandatory in case a pricing engine is used.

Reimplemented in Bond, SyntheticCDO, CPISwap, CreditDefaultSwap, FloatFloatSwap, ZeroCouponInflationSwap, VanillaSwap, NthToDefault, YearOnYearInflationSwap, EnergyCommodity, CPICapFloor, AssetSwap, NonstandardSwap, IrregularSwap, VarianceSwap, QuantoVanillaOption, Swap, OneAssetOption, ForwardVanillaOption, MultiAssetOption, QuantoDoubleBarrierOption, QuantoBarrierOption, MargrabeOption, and QuantoForwardVanillaOption.

void calculate | ( |  | ) | const
| protectedvirtual

This method performs all needed calculations by calling the performCalculations method.

Warning:
  Objects cache the results of the previous calculation. Such results will be returned upon later invocations of calculate. When the results depend on arguments which could change between invocations, the lazy object must register itself as observer of such objects for the calculations to be performed again when they change.

Warning:
  Should this method be redefined in derived classes, LazyObject::calculate() should be called in the overriding method.

Reimplemented from LazyObject.

void setupExpired | ( |  | ) | const
| protectedvirtual

This method must leave the instrument in a consistent state when the expiration condition is met.

Reimplemented in CreditDefaultSwap, Bond, Swap, RiskyBond, VarianceSwap, OneAssetOption, PathMultiAssetOption, and MultiAssetOption.

void performCalculations | ( |  | ) | const
| protectedvirtual

In case a pricing engine is not used, this method must be overridden to perform the actual calculations and set any needed results. In case a pricing engine is used, the default implementation can be used.

Implements LazyObject.

Reimplemented in FixedRateBondForward, Forward, RiskyBond, ConvertibleBond, CompositeInstrument, EnergyVanillaSwap, EnergyBasisSwap, EnergyFuture, and Stock.